/*
                                +---------------------------------+
                                |                                 |
                                |         ***   BSP   ***         |
                                |                                 |
                                |  Copyright  -tHE SWINe-  2002  |
                                |                                 |
                                |              Bsp.h              |
                                |                                 |
                                +---------------------------------+
*/

#ifndef __BSP_INCLUDED
#define __BSP_INCLUDED

enum {
    _Front   = 0x01,
    _Back    = 0x02,
    _OnPlane = 0x04,
    _Split   = 0x08
};

enum {
    _Have_Front_Node = 0x01,
    _Have_Back_Node  = 0x02
};

struct BSP_Material {
    char name[256];
};

struct BSP_Node {
    int flags;
    struct BSP_Node *front, *back;
    int rootpoly;
    Plane rootpl;
    Face_List face, onplane;
    Vertex_List *vertex;
};

struct BSP_Tree {
    Vertex_List vertex;
    Face_List face;
    BSP_Node *root;
    int n_material_num;
    BSP_Material *material;
};

void UpdateStatus();
BSP_Tree *CreateTree(World *svet);
int CreateNode(BSP_Node *nod);
int FindRootPoly(BSP_Node *nod);
int PartitionSpace(BSP_Node *nod);
Vertex IntEdgePlane(Vertex *in1, Vertex *in2, Plane *pl);
int SplitPolygon(BSP_Node *nod, Face *fac, 
   Face_List *front, Face_List *back);
int WriteTree(BSP_Tree *tree, char *f_name);
int ClassifyVertexPl(Plane *pl, Vertex *vtx);
int ClassifyFacePl(Plane *pl, Face *fac);

#endif