/*
								+---------------------------------+
								|                                 |
								|     ***   List manager   ***    |
								|                                 |
								|  Copyright  -tHE SWINe-  2002  |
								|                                 |
								|            List.cpp             |
								|                                 |
								+---------------------------------+
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "Load_3ds.h"
#include "Matrix.h"
#include "List.h"
#include "Bsp.h"

// vyprazdni Vertex list
int Init_VertexList(Vertex_List *list)
{
	list->n_vertex_num = 0;
	list->vertex = (Vertex**) malloc(0);
	// init Vertex array

	return 1;
}

// uvolni Vertexlist z pameti
int Destroy_VertexList(Vertex_List *list)
{
	if(list->n_vertex_num > 0) {
		list->n_vertex_num = 0;
		free((void*)list->vertex);
		// free up Vertex array

		return 1;
	}

	return 0;
}

// vrati index Vertexu v v listu list, pokud
// je nalezen. jinak vrati -1
int FindVertexInList(Vertex *v, Vertex_List *list)
{
	Vertex *a;
	int i;

	for(i = 0; i < list->n_vertex_num; i ++) {
		a = list->vertex[i];
		if(a->x == v->x && a->y == v->y && a->z == v->z &&
		   a->u == v->u && a->v == v->v) {
			return i;
		}
		// searching for Vertex
	}

	return -1;
}

// prida do seznamu list Vertex vtx
Vertex *AddVertexToList(Vertex *vtx, Vertex_List *list)
{
	Vertex *tmp;

	tmp = (Vertex*)malloc(sizeof(Vertex));
	if((list->vertex = (Vertex**) realloc(list->vertex,
	   ++ list->n_vertex_num * sizeof(Vertex*))) == NULL)
		return NULL;

	memcpy(tmp, vtx, sizeof(Vertex));
	list->vertex[list->n_vertex_num - 1] = tmp;

	return list->vertex[list->n_vertex_num - 1];
}

// nastavi facelist na prazdny
int Init_FaceList(Face_List *list)
{
	list->n_face_num = 0;
	list->face = (Face**) malloc(0);
	// init Vertex array

	return 1;
}

// uvolni facelist z pameti
int Destroy_FaceList(Face_List *list)
{
	if(list->n_face_num > 0) {
		list->n_face_num = 0;
		free((void*)list->face);
		// free up Vertex array

		return 1;
	}

	return 0;
}

// prida face do seznamu list
Face *AddFaceToList(Face *face, Face_List *list)
{
	Face *tmp;

	tmp = (Face*)malloc(sizeof(Face));
	if((list->face = (Face**) realloc(list->face,
	   ++ list->n_face_num * sizeof(Face*))) == NULL)
		return NULL;

	memcpy(tmp, face, sizeof(Face));
	list->face[list->n_face_num - 1] = tmp;

	return list->face[list->n_face_num - 1];
}

// pripoji facelist src_list k dest_list.
// po dokonceni muze byt src_list uvolnen z pameti
int Append_FaceList(Face_List *dest_list, Face_List *src_list)
{
	int i;

	for(i = 0; i < src_list->n_face_num; i ++) {
		if(AddFaceToList(src_list->face[i], dest_list) == NULL)
			return 0;
	}

	return 1;
}