/*
								+---------------------------------+
								|                                 |
								|        ***   Main   ***         |
								|                                 |
								|  Copyright  -tHE SWINe-  2002  |
								|                                 |
								|            Main.cpp             |
								|                                 |
								+---------------------------------+
*/

#include <stdio.h>
#include <string.h>
#include "Load_3ds.h"
#include "Matrix.h"
#include "List.h"
#include "Bsp.h"
#include "Main.h"

#define PI ((float)3.14159265358979323846264338327955)

void main(int argc, char *argv[])
{
	char f_name[256], *ptr;
	BSP_Tree *tree;
	World *wld;
	char short_str[256];

	Logo();
	// vytiskne logo programu

	if(argc == 1) {
		ErrMsg("Ussage is BSP_Comp.exe [filename] !\n");
		getchar();
		return;
	}
	// spocita argumenty

	strcpy(short_str, argv[1]);
	Create_8_3_Name(short_str);
	// vytvori dosove (kratke) jmeno souboru

	strcpy(f_name, argv[1]);
	if((ptr = strrchr(f_name, '.')) == NULL)
		strcat(f_name, ".bsp");
	else
		strcpy(ptr, ".bsp");
	// vytvori jmeno vystupniho souboru

	printf("   Loading file %s .. ", short_str);
	if((wld = Load_3DS(argv[1])) == NULL) {
		ErrMsg("File not found / is damaged !");
		getchar();
		return;
	}
	printf("Done\n\n");
	// nahraje 3ds

	tree = CreateTree(wld);
	// vytvori strom ..

	printf("\n");

	WriteTree(tree, f_name);
	// .. a zapise ho.

	getchar();
}

// vytiskne logo BSP
void Logo()
{
	printf("\n");
	printf("      ͻ   ͻ  ͻ   \n");
	printf("      Ȼ  ͻ Ȼ    ͻ   Ȼ  ͻ     \n");
	printf("                     ͼ             \n");
	printf("         ͼ      ͻ     ͼ     \n");
	printf("         ͻ    ͻ       ͼ   \n");
	printf("                ͻ                    \n");
	printf("      ɼ  ͼ ɼ   ͼ    ɼ  Ȼ         \n");
	printf("      ͼ   ͼ  ͼ         \n");
	printf("\n");
	printf("   BSP - Compiller v5.0 by -tHE SWINe- (C) 2002 \n\n");
}

// vytiskne chybovou zpravu
void ErrMsg(char *msg)
{
	printf("\r   # ERROR : %s \n", msg);
}

// vytvori jmeno v 8.3 formatu (vrati jej zpatky do str)
void Create_8_3_Name(char *str)
{
	char tmp[256];

	if(strrchr(str, '\\') != NULL)
		strcpy(tmp, strrchr(str, '\\'));
	else
		strcpy(tmp, str);
	// cut filename from path

	if(strlen(tmp) > 11) {
		if(stricmp(".3ds", &tmp[strlen(tmp) - 4]) == 0) {
			tmp[7] = 0;
			strcat(tmp, "~1.3ds");
		} else {
			tmp[9] = 0;
			strcat(tmp, "~1");
		}
	}
	// put filename to 8.3 format

	strcpy(str, tmp);
}